﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.5
@EndOfDesignText@
Sub Process_Globals
	Private timer1 As Timer
	Private currentIndex As Int = -1
'	Dim n As Notification
End Sub

Sub Service_Create
	timer1.Initialize("timer1", 1000)
End Sub

Sub Service_Start (StartingIntent As Intent)
'	Service.StartForeground(1, CreateNotification("Alarm Running", "Your alarm is active."))
	' Start the alarm process
	StartAlarm
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

Sub Service_Destroy
	
End Sub

Sub StartAlarm
	For i = 0 To B4XPages.MainPage.if_flexgridtabledetailslist.RowCount - 1
		B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(i,3,"")
		B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(i,3,"Pending")
		B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(i,2,"")
	Next
	currentIndex = -1
	Timer1_Tick
End Sub

Sub Timer1_Tick
	timer1.Enabled = False ' Disable the timer
    
	If currentIndex >= 0 Then ' This isn't the first tick
		B4XPages.MainPage.imedia_player.Load(File.DirAssets, "beepsound.mp3")
		B4XPages.MainPage.imedia_player.Play
		Sleep(1000)
		B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(currentIndex, 3, "")
		B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(currentIndex, 3, "Completed")
	End If

	currentIndex = currentIndex + 1

	If currentIndex > B4XPages.MainPage.if_flexgridtabledetailslist.RowCount - 1 Then
		StopService(Me) ' Stop service when the alarm finishes
		Return
	End If

	' Set the next alarm interval based on the flexgrid data
	Dim rowdata As List = B4XPages.MainPage.if_flexgridtabledetailslist.GetCellRow(currentIndex)
	Dim ls_totaltime As String = rowdata.Get(1)
    
	Dim parts() As String
	parts = Regex.Split(" ", ls_totaltime)
    
	Dim ls_time As String = parts(0)
	Dim ls_minsec As String = parts(1)
    
	Dim msecs As Long
	If ls_minsec = "Minutes" Then
		msecs = ls_time * DateTime.TicksPerMinute
	Else If ls_minsec = "Seconds" Then
		msecs = ls_time * DateTime.TicksPerSecond
	End If
    
	timer1.Interval = msecs
	
	DateTime.TimeFormat = "hh:mm:ss"
	B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(currentIndex,2, DateTime.Time(DateTime.Now + msecs - 2000))
	Log("next alarm at : " & DateTime.Time(DateTime.Now + msecs - 2000))
	timer1.Enabled = True
	
	timer1.Enabled = True
End Sub

'Sub CreateNotification(Title As String, Text As String) As Notification
'	Dim n As Notification
'	n.Initialize
'	n.Icon = "icon" ' Your app icon
'	n.SetInfo(Title, Text, Main) ' Main is the activity to open on tap
'	Return n
'End Sub

'Sub Timer1_Tick
'    timer1.Enabled = False ' Disable the timer
'    If currentIndex >= 0 Then ' This isn't the first tick
'        B4XPages.MainPage.imedia_player.Load(File.DirAssets, "beepsound.mp3")
'        B4XPages.MainPage.imedia_player.Play
'        Sleep(1000)
'        B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(currentIndex, 3, "Completed")
'    End If
'    currentIndex = currentIndex + 1
'    If currentIndex > B4XPages.MainPage.if_flexgridtabledetailslist.RowCount - 1 Then
'        StopService(Me) ' Stop service when the alarm finishes
'        Return
'    End If
'    
'    ' Set the next alarm interval based on the FlexGrid data
'    Dim rowdata As List = B4XPages.MainPage.if_flexgridtabledetailslist.GetCellRow(currentIndex)
'    Dim ls_totaltime As String = rowdata.Get(1)
'    Dim parts() As String
'    parts = Regex.Split(" ", ls_totaltime)
'    Dim ls_time As String = parts(0)
'    Dim ls_minsec As String = parts(1)
'    Dim msecs As Long
'    If ls_minsec = "Minutes" Then
'        msecs = ls_time * DateTime.TicksPerMinute
'    Else If ls_minsec = "Seconds" Then
'        msecs = ls_time * DateTime.TicksPerSecond
'    End If
'    timer1.Interval = msecs
'    DateTime.TimeFormat = "hh:mm:ss"
'    B4XPages.MainPage.if_flexgridtabledetailslist.SetCellValue(currentIndex, 2, DateTime.Time(DateTime.Now + msecs - 2000))
'    Log("Next alarm at : " & DateTime.Time(DateTime.Now + msecs - 2000))
'    timer1.Enabled = True
'End Sub

