﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Dim ix_xui As XUI
	Dim is_access As Accessibility
	Dim timer1 As Timer
'	Dim currentIndex As Int = -1
'	Dim msecs As Long = 1000
		
	Public imedia_player As MediaPlayer
	Public is_nexttime As Long
	Dim fileName As String = "alarm_schedule.json"
	Dim filedir As String = File.DirDefaultExternal
	Dim jsonParser As JSONParser

	Private btn_setalarmtiming As Button
	Private btn_startalarm As Button
	Private ilbl_heading As Label
	Public if_flexgridtabledetailslist As FlexGrid
	Private ilbl_details As Label
	Private ip_detailstablepanel As Panel
	Private btn_savetable As Button
	Private edit_time As EditText
	Private ilbl_minsec As Label
	Private ilbl_time As Label
	Private pnl_minsec As Panel
	Private pnl_time As Panel
	Private spnr_minsec As Spinner
	Private pnl_setalarm As Panel
	
	Private btn_cancel As Button
	Private ilbl_status As Label
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	
	Root.LoadLayout("alarm_sound")
	 
	imedia_player.Initialize2("MP")
	timer1.Initialize("Timer1", 1000)
	 
	pnl_setalarm.Visible = False
	edit_time.Color = Colors.Transparent
	
	if_flexgridtabledetailslist.Font = ix_xui.CreateFont(Typeface.DEFAULT, 14/is_access.GetUserFontScale)
	if_flexgridtabledetailslist.HeaderFont = ix_xui.CreateFont(Typeface.DEFAULT, 15/is_access.GetUserFontScale)
	
	if_flexgridtabledetailslist.ColsName = Array As String("S.No", "Duration", "Next Alarm Time", "Status")
													   
	if_flexgridtabledetailslist.ColsWidth = Array As Int(100dip, 150dip, 150dip, 150dip)
														 
	if_flexgridtabledetailslist.ColsType = Array As Int(if_flexgridtabledetailslist.TypeInt, if_flexgridtabledetailslist.TypeString, if_flexgridtabledetailslist.TypeString, if_flexgridtabledetailslist.TypeString)
													
	if_flexgridtabledetailslist.ColsAlignment = Array As String("CENTER", "CENTER", "CENTER", "CENTER")
	
	spnr_minsec.AddAll(Array As String ("Seconds", "Minutes"))
	
	DisplayTableRecords
	
	ilbl_status.Text = "Alarm Not Started"
	
End Sub

Sub DisplayTableRecords
	If File.Exists(filedir, fileName) = True Then
		
		Dim jsonString As String = File.ReadString(filedir, fileName)

		jsonParser.Initialize(jsonString)
		Dim data As List = jsonParser.NextArray
		
		Dim ls_sno As Int = 0
		
		For Each coldata As Map In data
			ls_sno = ls_sno + 1
			
			Dim ls_duration As String = coldata.Get("Time")
			Dim ls_status As String = "Pending"
			
			if_flexgridtabledetailslist.AddRow(Array As Object(ls_sno, ls_duration, "", ls_status),False)
			if_flexgridtabledetailslist.SetColAlignment(0,"CENTER")
		Next
	End If
End Sub

Private Sub btn_savetable_Click
	If edit_time.Text == "" Then
		Return
	End If
	
	Dim ls_sno As Int = 0
	
	If if_flexgridtabledetailslist.RowCount == 0 Then
		ls_sno = 0
	Else If if_flexgridtabledetailslist.RowCount > 0 Then
		For i = 0 To if_flexgridtabledetailslist.RowCount - 1
			ls_sno = if_flexgridtabledetailslist.GetCellValue(i,0)
		Next
	End If
	
	Dim row(4) As Object
	
	row(0) = ls_sno + 1
	row(1) = edit_time.Text.Trim & " " & spnr_minsec.SelectedItem
	row(2) = ""
	row(3) = "Pending"
	
	if_flexgridtabledetailslist.AddRow(row, False)
	if_flexgridtabledetailslist.SetColAlignment(0,"CENTER")
	
	pnl_setalarm.Visible = False
	btn_setalarmtiming.Enabled = True
	btn_startalarm.Enabled = True
	
	edit_time.Text = ""
	spnr_minsec.SelectedIndex = 0
	
	Dim ime As IME
	ime.Initialize("ime")
	ime.HideKeyboard
	
	DatatoJSON
	
End Sub

Private Sub btn_setalarmtiming_Click
	pnl_setalarm.Visible = True
	btn_setalarmtiming.Enabled = False
	btn_startalarm.Enabled = False
End Sub

Private Sub btn_startalarm_Click
	CallSubDelayed(AlarmService, "StartAlarm") ' Start the alarm service
	ToastMessageShow("Alarm Started", False)
End Sub

'Private Sub btn_startalarm_Click
'	
'	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
'		if_flexgridtabledetailslist.SetCellValue(i,3,"")
'		if_flexgridtabledetailslist.SetCellValue(i,3,"Pending")
'		if_flexgridtabledetailslist.SetCellValue(i,2,"")
'	Next
'	
'	currentIndex = -1
'	ToastMessageShow("Alarm Started", False)
'	Timer1_Tick
'End Sub
'
'Sub Timer1_Tick
'
'	timer1.Enabled = False ' Disable the timer
'
'	If currentIndex >= 0 Then
'		imedia_player.Load(File.DirAssets, "beepsound.mp3")
'		imedia_player.Play
'		Sleep(1000)
'		if_flexgridtabledetailslist.SetCellValue(currentIndex, 3, "")
'		if_flexgridtabledetailslist.SetCellValue(currentIndex, 3, "Completed")
'	End If
'
'	currentIndex = currentIndex + 1
'
'	If currentIndex > if_flexgridtabledetailslist.RowCount - 1 Then
'		ilbl_status.Text = "Alarm Finished"
'		Return
'	End If
'
'	Dim rowdata As List = if_flexgridtabledetailslist.GetCellRow(currentIndex)
'	Dim ls_totaltime As String = rowdata.Get(1)
'		
'	Dim parts() As String
'	parts = Regex.Split(" ", ls_totaltime)
'
'	Dim ls_time As String = parts(0)
'	Dim ls_minsec As String = parts(1)
'	
'	If ls_minsec = "Minutes" Then
'		msecs = ls_time * DateTime.TicksPerMinute
'	Else If ls_minsec = "Seconds" Then
'		msecs = ls_time * DateTime.TicksPerSecond
'	End If
'
'	timer1.Interval = msecs
'	
'	DateTime.TimeFormat = "hh:mm:ss"
'	if_flexgridtabledetailslist.SetCellValue(currentIndex, 2 , DateTime.Time(DateTime.Now + msecs - 1000))
'	Log("next alarm at : " & DateTime.Time(DateTime.Now + msecs - 1000))
'	timer1.Enabled = True
'	
'End Sub

Sub DatatoJSON
	Dim list_data As List
	list_data.Initialize
    
	For i = 0 To if_flexgridtabledetailslist.RowCount - 1
		Dim rowdata As List = if_flexgridtabledetailslist.GetCellRow(i)
        
		Dim map_data As Map
		map_data.Initialize
		
		map_data.Put("Time", rowdata.Get(1))
        
		list_data.Add(map_data)
	Next
    
	Dim json As JSONGenerator
	json.Initialize2(list_data)
	Dim jsonString As String = json.ToString
	Log(jsonString)
	
	Dim lr_runtimepermission As RuntimePermissions
	lr_runtimepermission.GetSafeDirDefaultExternal("")
	
	File.WriteString(filedir, fileName, jsonString)
	
End Sub

Private Sub if_flexgridtabledetailslist_CellLongClick(Row As Int, Col As Int)
		
	Msgbox2Async("Do You Want to Delete This Row?", "Attention!!", "Yes", "", "No", Null, False)
	Wait For Msgbox_Result (Result As Int)
	
	If Result == DialogResponse.POSITIVE Then
		if_flexgridtabledetailslist.RemoveRow(Row)
		DatatoJSON
	End If
		
End Sub

Private Sub btn_cancel_Click
	If pnl_setalarm.Visible = True Then
		pnl_setalarm.Visible = False
		btn_setalarmtiming.Enabled = True
		btn_startalarm.Enabled = True
	
		edit_time.Text = ""
		spnr_minsec.SelectedIndex = 0
	End If
End Sub

Private Sub if_flexgridtabledetailslist_CellClick(Row As Int, Col As Int)
	Dim Data As List = if_flexgridtabledetailslist.GetCellRow(Row)
	
	Dim ls_totaltime As String = Data.Get(1)
	Log("time : " & ls_totaltime)
	
	Dim parts() As String

	parts = Regex.Split(" ", ls_totaltime)

	Dim ls_time As String = parts(0)
	Dim ls_minsec As String = parts(1)

	Log("Time: " & ls_time)
	Log("Unit: " & ls_minsec)
End Sub